import tkinter as tk
from tkinter import ttk
from tkinter import messagebox

class Patient:
    """Beschreibung der Klasse Patient"""

    def __init__(self, s):
        """Konstruktor des Patienten"""
        self.name = s

    def InformationAusgeben(self):
        """Gibt Information über den Patienten aus"""
        print(self.name)

    def NameGeben(self):
        """Gibt den Namen des Patienten zurück"""
        return self.name


class Warteschlange:
    """Beschreibung der Warteschlange"""

    def __init__(self):
        """Konstruktor der Warteschlange"""
        self.patientenfeld = []

    def Einfügen(self, patient_neu):
        """Fügt einen neuen Patienten am Ende der Warteschlange ein."""
        self.patientenfeld.append(patient_neu)

    def Entfernen(self):
        """Entfernt den ersten Patient aus der Warteschlange und gibt ihn aus."""
        if self.patientenfeld:
            return self.patientenfeld.pop(0)
        else:
            return None


class Fenster(tk.Tk):
    """Oberfläche zur Verwaltung der Warteschlange"""

    def __init__(self):
        """Konstruktor der Oberfläche"""
        super().__init__()
        self.title("Patientenverwaltung")
        self.geometry("300x220")
        self.resizable(False, False)
        self.w = Warteschlange()
        self.initialize_gui()

    def initialize_gui(self):
        """Initialisiert die GUI"""
        label_überschrift = tk.Label(self, text="Warteschlangenverwaltung", font=("MS Sans Serif", 17))
        label_überschrift.pack()

        label_unterüberschrift = tk.Label(self, text="Praxis Dr. Ted Tanus", font=("MS Sans Serif", 13, "bold"))
        label_unterüberschrift.pack()

        label_aufnehmen = tk.Label(self, text="Person in Warteschlange aufnehmen:", font=("MS Sans Serif", 13))
        label_aufnehmen.pack()

        self.textfeld_einfügen = tk.Entry(self)
        self.textfeld_einfügen.insert(0, "Name eingeben")
        self.textfeld_einfügen.pack()

        knopf_einfügen = tk.Button(self, text="Einfügen", command=self.einfügen)
        knopf_einfügen.pack()

        label_entfernen = tk.Label(self, text="Person aus Warteschlange entfernen:", font=("MS Sans Serif", 13))
        label_entfernen.pack()

        knopf_entfernen = tk.Button(self, text="Entfernen", command=self.entfernen)
        knopf_entfernen.pack()

        self.label_nächster = tk.Label(self, text="Zur Zeit kein Patient beim Arzt", font=("MS Sans Serif", 13))
        self.label_nächster.pack()

    def einfügen(self):
        """Fügt einen neuen Patienten in die Warteschlange ein"""
        name = self.textfeld_einfügen.get()
        self.w.Einfügen(Patient(name))

    def entfernen(self):
        """Entfernt den ersten Patienten aus der Warteschlange und zeigt ihn an"""
        entfernter = self.w.Entfernen()
        if entfernter:
            self.label_nächster.config(text="Beim Arzt: " + entfernter.NameGeben())
        else:
            self.label_nächster.config(text="Zur Zeit kein Patient beim Arzt")

if __name__ == "__main__":
    app = Fenster()
    app.mainloop()