class Patient:
    """Beschreibung der Klasse Patient"""
    
    def __init__(self, s):
        """Konstruktor des Patienten"""
        self.name = s
        self.nachfolger = None

    def NachfolgerSetzen(self, nf):
        """Nachfolger des Patienten setzen"""
        self.nachfolger = nf

    def NachfolgerGeben(self):
        """Gibt den Nachfolger des Patienten aus"""
        return self.nachfolger

    def InformationAusgeben(self):
        """Gibt Information über den Patienten aus"""
        print(self.name)

    def NameGeben(self):
        """Gibt den Namen des Patienten aus"""
        return self.name


class Warteschlange:
    """Beschreibung der Warteschlange"""
    def __init__(self): 
        """Konstruktor der Warteschlange"""
        self.anfang = None
        self.ende = None

    def Einfügen(self, patient_neu):
        """Fügt einen neuen Patienten am Ende der Warteschlange ein"""
        if self.anfang is None:
            self.anfang = patient_neu
        else:
            self.ende.NachfolgerSetzen(patient_neu)
        self.ende = patient_neu

    def Entfernen(self):
        """Entfernt den ersten Patient aus der Warteschlange und gibt ihn zurück"""
        pass

    def InformationAusgeben(self):
        """Gibt Information über die Warteschlange aus"""
        if self.anfang is not None:
            self.anfang.InformationAusgeben()


class Fenster:
    """Oberfläche zur Verwaltung der Warteschlange"""

    def __init__(self):
        """Konstruktor der Oberfläche"""
        import tkinter as tk

        self.root = tk.Tk()
        self.root.title("Patientenverwaltung")

        self.label_ueberschrift = tk.Label(self.root, text="Warteschlangenverwaltung", font=("MS Sans Serif", 17))
        self.label_ueberschrift.pack()

        self.label_unterueberschrift = tk.Label(self.root, text="Praxis Dr. Ted Tanus", font=("MS Sans Serif", 13, "bold"))
        self.label_unterueberschrift.pack()
        
        self.label_aufnehmen = tk.Label(self.root, text="Person in Warteschlange aufnehmen:", font=("MS Sans Serif", 13))
        self.label_aufnehmen.pack()
        
        self.textfeld_einfuegen = tk.Entry(self.root)
        self.textfeld_einfuegen.insert(0, "Name eingeben")
        self.textfeld_einfuegen.pack()

        self.knopf_einfuegen = tk.Button(self.root, text="Einfügen", command=self.einfuegen)
        self.knopf_einfuegen.pack()

        self.label_entfernen = tk.Label(self.root, text="Person aus Warteschlange entfernen:", font=("MS Sans Serif", 13))
        self.label_entfernen.pack()
        
        self.knopf_entfernen = tk.Button(self.root, text="Entfernen", command=self.entfernen)
        self.knopf_entfernen.pack()

        self.label_naechster = tk.Label(self.root, text="Zur Zeit kein Patient beim Arzt", font=("MS Sans Serif", 13))
        self.label_naechster.pack()

        self.w = Warteschlange()

    def einfuegen(self):
        """Schaltfläche zum Aufruf der Methode zum Einfügen eines Patienten, der im Textfeld eingetragen wurde"""
        name = self.textfeld_einfuegen.get()
        self.w.Einfügen(Patient(name))

    def entfernen(self):
        """Schaltfläche zum Aufruf der Methode zum Entfernen und Anzeigen eines Patienten"""
        entfernter = self.w.Entfernen()
        if entfernter is not None:
            self.label_naechster.config(text="Beim Arzt: " + entfernter.NameGeben())
        else:
            self.label_naechster.config(text="Zur Zeit kein Patient beim Arzt")

    def start(self):
        """Startet die Oberfläche"""
        self.root.mainloop()


if __name__ == "__main__":
    app = Fenster()
    app.start()