class Medium:
    """Beschreibung der Klasse Medium"""

    def __init__(self, s):
        """Konstruktor des Mediums"""
        self.name = "media/" + s
        self.nachfolger = None

    def NachfolgerSetzen(self, nf):
        """Setzt den Nachfolger des Mediums."""
        self.nachfolger = nf

    def NachfolgerGeben(self):
        """Gibt den Nachfolger des Mediums zurück."""
        return self.nachfolger

    def InformationAusgeben(self):
        """Gibt Informationen über das Medium aus."""
        print(self.name)

    def NameGeben(self):
        """Gibt den Namen des Mediums zurück."""
        return self.name

import tkinter as tk
from tkinter import ttk
import pygame

class Mediaplayer(tk.Tk):
    """Klasse zur Verwaltung eines Mediaplayers"""

    def __init__(self):
        """Konstruktor des Mediaplayers"""
        super().__init__()
        self.title("Audioplayer")
        self.geometry("650x500")

        self.initialize_player()

    def initialize_player(self):
        """Initialisiert den Player"""
        pygame.mixer.init()
        self.current_medium = Medium("audio1.wav")
        self.media_player = None
        self.play_button = ttk.Button(self, text=">", command=self.play_or_next)
        self.play_button.pack()

    def play_or_next(self):
        """Spielt das Medium ab oder geht zum nächsten"""
        if self.play_button["text"] == ">":
            pygame.mixer.music.load(self.current_medium.NameGeben())
            pygame.mixer.music.play()
            self.play_button["text"] = "nächstes"
        else:
            self.current_medium =  Medium("audio2.wav")
            if self.current_medium:
                pygame.mixer.music.load(self.current_medium.NameGeben())
                pygame.mixer.music.play()
                self.play_button["text"] = ">"
            else:
                self.play_button["text"] = "Ende der Warteschlange"

if __name__ == "__main__":
    app = Mediaplayer()
    app.mainloop()